QWToASCII    proc

 comment    * ------------------------------------------------------------
            Convert positive QWORD to ASCII string (no sign) by IanB.

            On entry:
                EAX/EDX = value to convert Lo/Hi
                ECX = pointer to string buffer (at least 20 chars long)
            On exit:
                ECX points to final digit in the string
                EDX = 1
                string buffer contains the ASCII string representation,
                null-terminated.
            EBX/EBP/EDI/ESI preserved
            ------------------------------------------------------------ *

        push    ebx
        push    esi
        mov     esi, edx                    ; copy value
        push    edi
        mov     edi, edx                    ; copy value
        mov     bh, "0"                     ; keep for convenience
        or      esi, eax                    ; can we skip all testing
        jz      Digit00
        test    edx, edx                    ; can we skip the slow top DWORD stuff
        jz      TestLowDWORD
        cmp     edi, 17H
        jb      Digit10
        jz      Digit10a
        cmp     edx, 0e8H
        jb      Digit11
        jz      Digit11a
        cmp     edi, 918H
        jb      Digit12
        jz      Digit12a
        cmp     edx, 5af3H
        jb      Digit13
        jz      Digit13a
        cmp     edi, 38d7eH
        jb      Digit14
        jz      Digit14a
        cmp     edx, 2386f2H
        jb      Digit15
        jz      Digit15a
        cmp     edi, 1634578H
        jb      Digit16
        jz      Digit16a
        cmp     edx, 0de0b6b3H
        jb      Digit17
        jz      Digit17a
        cmp     edi, 8ac72304H
        jb      Digit18
        jz      Digit18a

Digit19:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 89e80000H              ; 10,000,000,000,000,000,000
        sbb     esi, 8ac72304H
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit18

Digit18a:
        cmp     eax, 0a7640000H
        jb      Digit17

Digit18:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 0a7640000H             ; 1,000,000,000,000,000,000
        sbb     esi, 0de0b6b3H
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit17

Digit17a:
        cmp     eax, 5d8a0000H
        jb      Digit16

Digit17:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 5d8a0000H              ; 100,000,000,000,000,000
        sbb     esi, 1634578H
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit16

Digit16a:
        cmp     eax, 6fc10000H
        jb      Digit15

Digit16:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 6fc10000H              ; 10,000,000,000,000,000
        sbb     esi, 2386f2H
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit15

Digit15a:
        cmp     eax, 0a4c68000H
        jb      Digit14

Digit15:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 0a4c68000H             ; 1,000,000,000,000,000
        sbb     esi, 38d7eH
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit14

Digit14a:
        cmp     eax, 107a4000H
        jb      Digit13

Digit14:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 107a4000H              ; 100,000,000,000,000
        sbb     esi, 5af3H
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit13

Digit13a:
        cmp     eax, 4e72a000H
        jb      Digit12

Digit13:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 4e72a000H              ; 10,000,000,000,000
        sbb     esi, 918H
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit12

Digit12a:
        cmp     eax, 0d4a51000H
        jb      Digit11

Digit12:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 0d4a51000H             ; 1,000,000,000,000
        sbb     esi, 0e8H
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit11

Digit11a:
        cmp     eax, 4876e800H
        jb      Digit10

Digit11:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 4876e800H              ; 100,000,000,000
        sbb     esi, 17H
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit10

Digit10a:
        cmp     eax, 540be400H
        jb      Digit09


Digit10:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx
        mov     bl, bh
@@:
        sub     edi, 540be400H              ; 10,000,000,000
        sbb     esi, 2H
        jb      @F
        add     bl, 1
        mov     eax, edi                    ; copy good values back
        mov     edx, esi
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, 1
        jmp     Digit09                     ; must write all further digits!

TestLowDWORD:
        mov     esi, eax                    ; copy value
        mov     edx, 1                      ; convenience number
        cmp     eax, 0aH
        jb      Digit00
        cmp     esi, 64H
        jb      Digit01
        cmp     eax, 3e8H
        jb      Digit02
        cmp     esi, 2710H
        jb      Digit03
        cmp     eax, 186a0H
        jb      Digit04
        cmp     esi, 0f4240H
        jb      Digit05
        cmp     eax, 989680H
        jb      Digit06
        cmp     esi, 5f5e100H
        jb      Digit07
        cmp     eax, 3b9aca00H
        jb      Digit08

Digit09a:
        mov     edi, eax                    ; copy good value to test, no high DWORD
        mov     bl, bh
@@:
        sub     edi, 3b9aca00H              ; 1,000,000,000
        jb      WriteDigit09
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B

Digit09:
        mov     edi, eax                    ; copy good values to test
        mov     esi, edx                    ; there may still be a high DWORD
        mov     edx, 1                      ; but it's not needed now
        mov     bl, bh
@@:
        sub     edi, 3b9aca00H              ; 1,000,000,000
        sbb     esi, 0
        jb      WriteDigit09
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B

WriteDigit09:
        mov     [ecx], bl
        add     ecx, edx

Digit08:
        mov     edi, eax                    ; copy good value to test
        mov     bl, bh
@@:
        sub     edi, 5f5e100H               ; 100,000,000
        jb      @F
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit07:
        mov     edi, eax                    ; copy good value to test
        mov     bl, bh
@@:
        sub     edi, 989680H                ; 10,000,000
        jb      @F
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit06:
        mov     edi, eax                    ; copy good value to test
        mov     bl, bh
@@:
        sub     edi, 0f4240H                ; 1,000,000
        jb      @F
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit05:
        mov     edi, eax                    ; copy good value to test
        mov     bl, bh
@@:
        sub     edi, 186a0H                 ; 100,000
        jb      @F
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit04:
        mov     edi, eax                    ; copy good value to test
        mov     bl, bh
@@:
        sub     edi, 2710H                  ; 10,000
        jb      @F
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit03:
        mov     edi, eax                    ; copy good value to test
        mov     bl, bh
@@:
        sub     edi, 3e8H                   ; 1,000
        jb      @F
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit02:
        mov     edi, eax                    ; copy good value to test
        mov     bl, bh
@@:
        sub     edi, 64H                    ; 100
        jb      @F
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit01:
        mov     edi, eax                    ; copy good value to test
        mov     bl, bh
@@:
        sub     edi, 0aH                    ; 10
        jb      @F
        add     bl, dl
        mov     eax, edi                    ; copy good value back
        jmp     @B
@@:
        mov     [ecx], bl
        add     ecx, edx

Digit00:
        add     al, bh
        pop     edi
        pop     esi
        pop     ebx
        mov     [ecx], ax                   ; add null-termination
        ret

QWToASCII endp